package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

import java.util.ArrayList;
import java.util.Random;


public class AddressBook extends AbstractBehavior<AddressBook.Message> {
    ArrayList<ActorRef<Customer.Message>> customers = new ArrayList<>();
    public interface Message {}

    //Message, wenn ein Empfänger nach einer Adresse fragt
    public record CustomerMessage(ActorRef<Customer.Message> fragender, String nameFragender,ActorRef<DeliveryCar.Message> truckReference) implements Message{}

    @Override
    public Receive<AddressBook.Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(CustomerMessage.class, this::onCustomerMessage)
                .build();
    }

    //create Methode mit custo = der Liste der Empfänger
    public static Behavior<AddressBook.Message> create(ArrayList<ActorRef<Customer.Message>> custo){
        return Behaviors.setup(context -> new AddressBook(context, custo));
    }

    //Konstruktor von dem Adressbuch, in dem auch jedem Customer direkt eine Hello Nachricht geschickt wird, damit diese
    //das Adressbuch auch kennen (um nach Empfängern fragen zu können).
    private AddressBook(ActorContext<AddressBook.Message> context, ArrayList<ActorRef<Customer.Message>> custo){
        super(context);
        if(!custo.isEmpty()){
            this.customers.addAll(custo);
            for (ActorRef<Customer.Message> cst: this.customers) {
                cst.tell(new Customer.AddressHello(getContext().getSelf()));
            }
        }
    }

    //Methode, um einen zufälligen Empfänger auszugeben
    public Behavior<Message> onCustomerMessage(CustomerMessage msg){
        Random random = new Random();
        int index = random.nextInt(customers.size());
        var addressOf = customers.get(index);
        getContext().getLog().info("{} asked for an address",msg.nameFragender);
        msg.fragender.tell(new Customer.AddressMessage(addressOf, msg.truckReference));
        return this;
    }
}
