package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Receive;


import java.util.ArrayList;

//TODO: Timer Aktivitäten müssen hinzugefügt werden
//TODO: Delivery Nachricht für den Fall, dass der Truck ein Paket für den Customer hat, bei dem der Truck gerade ist
//Gedanke: Eventuell mit Overseer wie in Blatt 1 arbeiten für das Einhalten der Routen
//TODO: Pickup Nachricht an den Customer, wenn der Truck noch freie Plätze hat
//TODO: Arrive Nachricht
public class DeliveryCar extends AbstractBehavior<DeliveryCar.Message> {

    ArrayList<Paket> pakete;
    ArrayList<ActorRef<Customer.Message>> route;

    public record LoadMessage(ArrayList<Paket> pakete) implements  Message{}
    public interface Message {}

    public record PickupResponse(Paket paket) implements Message{}
    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(PickupResponse.class, this::onPickupResponse)
                .build();
    }

    private DeliveryCar(ActorContext<DeliveryCar.Message> context,ArrayList<ActorRef<Customer.Message>> route){
        super(context);
        this.route = route;

    }

    //Pakete aus dem Verteilzentrum einladen
    //TODO: Eventuell das losfahren und handlen, zu welchem Empfänger er fahren muss, mit einem Overseer Actor implementieren
    public Behavior<DeliveryCar.Message> onLoadMessage(LoadMessage msg){
        if(!msg.pakete.isEmpty()){
            this.pakete.addAll(msg.pakete);
        }
        //vielleicht sowas wie in Blatt 1 Lösung mit einem Overseer Actor und dann einem overseer Attribut im Konstruktor
        //this.overseer.tell(new Overseer.LoadedMessage()
        return this;
    }

    //Customer gibt PickupResponse entweder mit einem Paket oder ohne eins
    //Die Methode kann nur ausgeführt werden, wenn zuvor eine Pickup Nachricht an den Empfänger gesendet wurde und das
    //impliziert, dass der Truck noch Platz für weitere Pakete hat
    public Behavior<Message> onPickupResponse(PickupResponse rsp){
        if(rsp.paket != null){
            pakete.add(rsp.paket);
            getContext().getLog().info("Aktuelle Anzahl der Pakete im Truck: {}",pakete.size());
        }
        //TODO: Fall behandeln, dass kein Paket übergeben wurde (wahrscheinlich einfach Timer setzen)
        return this;
    }

}
